summaryrefslogtreecommitdiffstats
path: root/src/os-plugins/plugins/vmchooser/XX_vmchooser.sh
diff options
context:
space:
mode:
Diffstat (limited to 'src/os-plugins/plugins/vmchooser/XX_vmchooser.sh')
-rw-r--r--src/os-plugins/plugins/vmchooser/XX_vmchooser.sh57
1 files changed, 57 insertions, 0 deletions
diff --git a/src/os-plugins/plugins/vmchooser/XX_vmchooser.sh b/src/os-plugins/plugins/vmchooser/XX_vmchooser.sh
new file mode 100644
index 00000000..168bcda1
--- /dev/null
+++ b/src/os-plugins/plugins/vmchooser/XX_vmchooser.sh
@@ -0,0 +1,57 @@
+# Copyright (c) 2008, 2009 - RZ Uni Freiburg
+# Copyright (c) 2008..2010 - OpenSLX GmbH
+#
+# This program/file is free software distributed under the GPL version 2.
+# See http://openslx.org/COPYING
+#
+# If you have any feedback please consult http://openslx.org/feedback and
+# send your feedback to feedback@openslx.org
+#
+# General information about OpenSLX can be found at http://openslx.org
+#
+# script is included from init via the "." load function - thus it has all
+# variables and functions available
+
+# include default directories
+. /etc/openslx.conf
+
+CONFFILE="/initramfs/plugin-conf/vmchooser.conf"
+PLUGINCONFDIR=/mnt/${OPENSLX_DEFAULT_CONFDIR}/plugins/vmchooser
+BINDIR=/mnt/${OPENSLX_DEFAULT_BINDIR}
+PLUGINDIR=${OPENSLX_DEFAULT_DIR}/plugin-repo/vmchooser
+VIRTDIR=/mnt/${OPENSLX_DEFAULT_VIRTDIR}
+
+if [ -e $CONFFILE ]; then
+ . $CONFFILE
+ if [ $vmchooser_active -ne 0 ] ; then
+ [ $DEBUGLEVEL -gt 0 ] \
+ && echo "vmchooser: copying stage3 configuration file ..."
+ testmkd ${PLUGINCONFDIR}/loopimg
+ testmkd ${PLUGINCONFDIR}/fd-loop 1777
+ cp $CONFFILE ${PLUGINCONFDIR}/vmchooser.conf
+ ln -s ${PLUGINDIR}/run-virt.sh ${BINDIR}/run-virt.sh
+ ln -s ${PLUGINDIR}/vmchooser ${BINDIR}/vmchooser
+
+ # setup all generic virtualization / starting stuff like the floppy image
+ # loop file for exchanging information between linux and vm guest
+ if modprobe ${MODPRV} loop; then
+ mdev -s
+ else
+ : #|| error "" nonfatal
+ fi
+ # mount a clean tempfs (bug in UnionFS prevents loopmount to work)
+ grep -qE "unionfs |aufs " /proc/mounts && \
+ mount -n -o size=1500k -t tmpfs vm-loopimg ${PLUGINCONFDIR}/loopimg
+ # create an empty floppy image of 1.4MByte size
+ dd if=/dev/zero of=${PLUGINCONFDIR}/loopimg/fd.img count=2880 bs=512 \
+ 2>/dev/null
+ chmod 0777 ${PLUGINCONFDIR}/loopimg/fd.img
+ # use dos formatter copied into stage3
+ mkdosfs ${PLUGINCONFDIR}/loopimg/fd.img >/dev/null 2>&1 #|| error
+ mount -n -t msdos -o loop,umask=000 ${PLUGINCONFDIR}/loopimg/fd.img \
+ ${PLUGINCONFDIR}/fd-loop
+
+ # finished ...
+ [ $DEBUGLEVEL -gt 0 ] && echo "done with 'vmchooser' os-plugin ..."
+ fi
+fi